(******************************************************************
Devoteeù

Copyright (C) 2009 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Mar.04-09

TMCustomConfigPersistent:
    лûࡣ
TMCustomConfigSection:
    лöࡣֻ͡
TMCustomConfig:
    лࡣͺöΡṩLoad/Save
TMCustomConfigSerializer:
    лࡣ
TMIniSerializer:
    ñ浽INIļл
TMRegSerializer:
    ñ浽עл
******************************************************************)
unit MDConfig;

interface

uses
    Classes, TypInfo, SysUtils, IniFiles, Windows, Registry, MDComm
    {$IFDEF DELPHI}, IntfInfo, InvRules{$ENDIF};

type
{$M+}
    TMCustomConfigSection = class(TInterfacedObject, IMSerializable)
    Protected
      //  IMSerializable
      Procedure SerializeRead(  Ser : IMSerializer );
      Procedure SerializeWrite( Ser : IMSerializer );
    Public
        Procedure AfterConstruction; Override;
        Procedure Free;
    End;
{$M-}
    TMCustomConfig = class(TPersistent)
    Private
      FDefSer : IMSerializer;
    public
      Constructor Create(aDefaultSerializer : IMSerializer = Nil);
      Procedure Load(aSerializer : IMSerializer = Nil);
      Procedure Save(aSerializer : IMSerializer = Nil);
    End;

    TMCustomConfigSerializer = class(TInterfacedObject, IMSerializer)
    Protected
        FCurName : String;
        //  IMSerializer
        Function  NeedCount : Boolean;
        Function  ReadValueCount : Integer;
        Procedure WriteValueCount( aCount : Integer );
        Function  ReadValue(  aTypeInfo : PTypeInfo; aObj : TObject = Nil ) : Variant; Virtual; Abstract;
        Procedure WriteValue( aTypeInfo : PTypeInfo; const Value : Variant ); Virtual; Abstract;
        Procedure ReadObject(        aObj : TObject );
        Procedure WriteObject( const aObj : TObject );
(*    Public
        Procedure AfterConstruction; Override;
        Procedure Free; *)
    End;

    TMIniSerializer = class(TMCustomConfigSerializer)
    private
        FIniFile : TIniFile;
        FDefSection : String;
        FCurSection : String;
    protected
        //  IMSerializer
        //Function  NeedCount : Boolean;
        //Function  ReadValueCount : Integer;
        //Procedure WriteValueCount( aCount : Integer );
        Function  ReadValue(  aTypeInfo : PTypeInfo; aObj : TObject = Nil ) : Variant; Override;
        Procedure WriteValue( aTypeInfo : PTypeInfo; const Value : Variant ); Override;
        //Procedure ReadObject(        aObj : TObject ); Override;
        //Procedure WriteObject( const aObj : TObject ); Override;
    public
        constructor Create( aFileName : String; aDefSection : String = 'Default' );
        destructor Destroy; Override;
    End;

    TMRegSerializer = class(TMCustomConfigSerializer)
    private
        FReg : TRegistry;
    protected
        //  IMSerializer
        //Function  NeedCount : Boolean;
        //Function  ReadValueCount : Integer;
        //Procedure WriteValueCount( aCount : Integer );
        Function  ReadValue(  aTypeInfo : PTypeInfo; aObj : TObject = Nil ) : Variant; Override;
        Procedure WriteValue( aTypeInfo : PTypeInfo; const Value : Variant ); Override;
        //Procedure ReadObject(        aObj : TObject ); Override;
        //Procedure WriteObject( const aObj : TObject ); Override;
    public
        constructor Create( aRoot: HKEY; aKey: String );
        destructor Destroy; Override;
    End;

implementation

{ TMCustomConfigSection }

procedure TMCustomConfigSection.AfterConstruction;
begin
  inherited;
  _AddRef();
end;

procedure TMCustomConfigSection.Free;
begin
  _Release();
end;

procedure TMCustomConfigSection.SerializeRead(Ser: IMSerializer);
begin
  Ser.ReadObject(Self);
end;

procedure TMCustomConfigSection.SerializeWrite(Ser: IMSerializer);
begin
  Ser.WriteObject(Self);
end;

{ TMCustomConfig }

constructor TMCustomConfig.Create(aDefaultSerializer: IMSerializer);
begin
  FDefSer := aDefaultSerializer;
end;

procedure TMCustomConfig.Load(aSerializer: IMSerializer);
begin
  If Assigned( aSerializer ) Then
    aSerializer.ReadObject(Self)
  Else If Assigned( FDefSer ) Then
    FDefSer.ReadObject(Self)
  Else
    Raise Exception.Create('No serializer!');
end;

procedure TMCustomConfig.Save(aSerializer: IMSerializer);
begin
  If Assigned( aSerializer ) Then
    aSerializer.WriteObject(Self)
  Else If Assigned( FDefSer ) Then
    FDefSer.WriteObject(Self)
  Else
    Raise Exception.Create('No serializer!');
end;

{ TMCustomConfigSerializer }
(*
procedure TMCustomConfigSerializer.AfterConstruction;
begin
  inherited;
    _AddRef();
end;

procedure TMCustomConfigSerializer.Free;
begin
    _Release();
end;
*)
function TMCustomConfigSerializer.NeedCount: Boolean;
begin
    Result := false;
end;

procedure TMCustomConfigSerializer.ReadObject(aObj: TObject);
Var
    pList : TMPropList;
    pInfo : PPropInfo;
    i : Integer;
    tmpobj : TObject;
begin
    pList := TMPropList.Create( aObj );
    Try
        For i := 0 To pList.PropCount - 1 Do
        Begin
            pInfo := pList.Props[i];
            FCurName := pInfo^.Name;
            If ( pInfo^.PropType^.Kind = tkClass ) Then
            Begin
                tmpobj := TObject( Integer( GetPropValue( aObj, pInfo^.Name ) ) );
                ReadValue( pInfo^.PropType^, tmpobj );
            End
            Else
                Try
                    SetPropValue( aObj, pInfo^.Name, ReadValue( pInfo^.PropType^ ) );
                Except
                    //  discard all exception
                End;
        End;
    Finally
        pList.Free;
    End;
end;

function TMCustomConfigSerializer.ReadValueCount: Integer;
begin
    Result := 0;
end;

procedure TMCustomConfigSerializer.WriteObject(const aObj: TObject);
Var
    pList : TMPropList;
    pInfo : PPropInfo;
    i : Integer;
begin
    pList := TMPropList.Create( aObj );
    Try
        For i := 0 To pList.PropCount - 1 Do
        Begin
            pInfo := pList.Props[i];
            FCurName := pInfo^.Name;
            WriteValue( pInfo^.PropType^, GetPropValue( aObj, pInfo^.Name ) );
        End;
    Finally
        pList.Free;
    End;
end;

procedure TMCustomConfigSerializer.WriteValueCount(aCount: Integer);
begin
    // do nothing
end;

{ TMIniSerializer }

constructor TMIniSerializer.Create(aFileName: String; aDefSection: String);
begin
    FIniFile := TIniFile.Create(aFileName);
    FDefSection := aDefSection;
    FCurSection := FDefSection;
    FCurName := '';
end;

destructor TMIniSerializer.Destroy;
begin
    FIniFile.Free;
end;

function TMIniSerializer.ReadValue(aTypeInfo: PTypeInfo;
  aObj: TObject): Variant;
begin
    Result   := 0;
    If ( aTypeInfo^.Kind = tkClass ) Then
    Begin
        If ( aObj Is TMCustomConfigSection ) Then
        Begin
            FCurSection := FCurName;
            ReadObject( aObj );
            FCurSection := FDefSection;
        End
    End
    Else
        Result := FIniFile.ReadString(FCurSection,FCurName,'');
end;

procedure TMIniSerializer.WriteValue(aTypeInfo: PTypeInfo;
  const Value: Variant);
Var
    obj   : TObject;
begin
    If ( aTypeInfo^.Kind = tkClass ) Then
    Begin
      obj := TObject( Integer( Value ) );
      If ( obj Is TMCustomConfigSection ) Then
      Begin
        FCurSection := FCurName;
        WriteObject( obj );
        FCurSection := FDefSection;
      End
    End
    Else
      FIniFile.WriteString(FCurSection,FCurName, String(Value));
end;

{ TMRegSerializer }

constructor TMRegSerializer.Create(aRoot: HKEY; aKey: String);
begin
    FReg := TRegistry.Create;
    FReg.RootKey := aRoot;
    FReg.OpenKey(aKey, true);
end;

destructor TMRegSerializer.Destroy;
begin
    FReg.Free;
end;

function TMRegSerializer.ReadValue(aTypeInfo: PTypeInfo;
  aObj: TObject): Variant;
Var
    curpath : String;
begin
    Result := 0;
    Case aTypeInfo^.Kind Of
    tkClass:
    Begin
        If ( aObj Is TMCustomConfigSection ) Then
        Begin
            curpath := FReg.CurrentPath;
            FReg.OpenKey(FCurName,true);
            ReadObject( aObj );
            FReg.CloseKey();
            FReg.OpenKey(curpath, false);
        End
    End;
    tkInteger, tkChar, tkEnumeration, tkWChar, tkInt64:
        Result := FReg.ReadInteger(FCurName);
    tkFloat:
        Result := FReg.ReadFloat(FCurName);
    Else
        Result := FReg.ReadString(FCurName);
    End;
end;

procedure TMRegSerializer.WriteValue(aTypeInfo: PTypeInfo;
  const Value: Variant);
Var
    obj   : TObject;
    curpath:String;
begin
    Case aTypeInfo^.Kind Of
    tkClass:
    Begin
      obj := TObject( Integer( Value ) );
      If ( obj Is TMCustomConfigSection ) Then
      Begin
        curpath := FReg.CurrentPath;
        FReg.OpenKey(FCurName,true);
        WriteObject( obj );
        FReg.CloseKey();
        FReg.OpenKey(curpath,false);
      End
    End;
    tkInteger, tkChar, tkEnumeration, tkWChar, tkInt64:
        FReg.WriteInteger(FCurName, Integer(Value));
    tkFloat:
        FReg.WriteFloat(FCurName, Double(Value));
    Else
      FReg.WriteString(FCurName, String(Value));
    End;
end;

end.

