(******************************************************************
Delphiͨлʵ֡

Copyright (C) 2005, 07 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Feb.09-05, Feb.20, Mar.06, Mar.28, Dec.01-07

TMStreamSerializerлͨелʵ֡
TMXMLSerializerлXMLелʵ֡

050413  ӶIMStateSerializable֧
050416  ޸TMXMLSerializerʵ
050827  ΪIMStatefulSerializable
071201  ޸TMStreamSerializerеString/WideStringͣȥ#0

ֲοLex CHowĿ-lexlibشл
******************************************************************)
unit MSerializ;

interface

Uses
  Classes, SysUtils, TypInfo, InvRules, XMLIntf, MDComm;

Type
  TMStreamSerializer = class( TInterfacedObject, IMSerializer )
  private
    FStrm : TStream;
  protected
    Function  NeedCount : Boolean;
    Function  ReadValueCount : Integer;
    Procedure WriteValueCount( aCount : Integer );
    Function  ReadValue(  aTypeInfo : PTypeInfo; aObj : TObject = Nil ) : Variant;
    Procedure WriteValue( aTypeInfo : PTypeInfo; const Value : Variant );
    Procedure ReadObject(        aObj : TObject );
    Procedure WriteObject( const aObj : TObject );
  public
    constructor Create( aStrm : TStream );
    Procedure Free;
  End;

  TMXMLSerializer = class( TInterfacedObject, IMSerializer )
  private
    FNode : IXMLNode;
    FCurNode : IXMLNode;
    FCurName : String;
  protected
    Function  NeedCount : Boolean;
    Function  ReadValueCount : Integer;
    Procedure WriteValueCount( aCount : Integer );
    Function  ReadValue(  aTypeInfo : PTypeInfo; aObj : TObject = Nil ) : Variant;
    Procedure WriteValue( aTypeInfo : PTypeInfo; const Value : Variant );
    Procedure ReadObject(        aObj : TObject );
    Procedure WriteObject( const aObj : TObject );
  public
    constructor Create( aNode : IXMLNode; aName : String );
    Procedure Free;
  End;

implementation

Uses
    RTLConsts;

const
  csTypeKindFilter : TTypeKinds = [{tkUnknown, }tkInteger, tkChar, tkEnumeration,
    tkFloat, tkString, tkSet, tkClass, {tkMethod, }tkWChar, tkLString,
    tkWString, tkVariant, {tkArray, tkRecord, tkInterface, tkDynArray, }
    tkInt64];
  csSequence = 'Sequence';

{ TMStreamSerializer }

constructor TMStreamSerializer.Create(aStrm: TStream);
begin
  Inherited Create;
  FStrm := aStrm;
  _AddRef( );
end;

function TMStreamSerializer.NeedCount: Boolean;
begin
    Result := true;
end;

function TMStreamSerializer.ReadValueCount: Integer;
begin
    Result := ReadValue( TypeInfo( Integer ) );
end;

procedure TMStreamSerializer.WriteValueCount(aCount: Integer);
begin
    WriteValue( TypeInfo( Integer ), aCount );
end;

function TMStreamSerializer.ReadValue(aTypeInfo: PTypeInfo; aObj : TObject): Variant;
Var
    buf   : Array [0..15] Of Byte;
    nSize : Integer;
    intf  : IMSerializable;
begin
    FillChar( buf, 16, 0 );
    nSize := GetTypeSize( aTypeInfo );
    Case aTypeInfo^.Kind Of
      tkClass :
      Begin
        If Assigned( aObj ) Then
        Begin
          If Supports( aObj, IMStatefulSerializable, intf )
            OR Supports( aObj, IMSerializable, intf ) Then
          Begin
            intf.SerializeRead( self );
            intf := Nil;
          End
          Else
              ReadObject( aObj );
        End
        Else
          raise EPropertyConvertError.CreateResFmt(@SInvalidPropertyType,
                                                   [aTypeInfo^.Name]);
      End;
      tkRecord :
      Begin
        If ( aTypeInfo^.Name = csTGUID ) Then
          Result := GUIDToString( PGUID( @buf[0] )^ )
      End;
      tkString, tkLString :
      Begin
        FStrm.Read( nSize, sizeof( nSize ) );
        SetLength( PString( @buf[0] )^, nSize );
        FStrm.Read( PChar( PString( @buf[0] )^ )^, nSize );
        Result := PString( @buf[0] )^;
      End;
      tkWString :
      Begin
        FStrm.Read( nSize, sizeof( nSize ) );
        SetLength( PWideString( @buf[0] )^, nSize );
        FStrm.Read( PWideChar( PWideString( @buf[0] )^ )^, nSize * 2 );
        Result := PWideString( @buf[0] )^;
      End;
    Else
      Begin
        FStrm.Read( buf, nSize );
        Result := GetVariantFromPointer( aTypeInfo, @buf[0] );
      End;
    End;
end;

procedure TMStreamSerializer.WriteValue(aTypeInfo: PTypeInfo;
  const Value: Variant);
Var
    buf   : Array [0..15] Of Byte;
    p     : Pointer;
    nSize : Integer;
    obj   : TObject;
    intf  : IMSerializable;
begin
    FillChar( buf, 16, 0 );
    p := @buf[0];
    nSize := GetTypeSize( aTypeInfo );
    If ( aTypeInfo^.Kind = tkClass ) Then
    Begin
      obj := TObject( Integer( Value ) );
      If Supports( obj, IMStatefulSerializable, intf )
        OR Supports( obj, IMSerializable, intf ) Then
      Begin
          intf.SerializeWrite( Self );
          intf := Nil;
      End
      Else
          WriteObject( obj );
    End
    Else
    Begin
      SetVariantToPointer( aTypeInfo, @buf[0], Value );
      Case aTypeInfo^.Kind Of
        tkString, tkLString:
        Begin
          p := Pointer( PInteger( @buf )^ );
          nSize := Length( String( Value ) );
          FStrm.Write( nSize, SizeOf( nSize ) );
        End;
        tkWString:
        Begin
          p := Pointer( PInteger( @buf )^ );
          nSize := Length( WideString( Value ) );
          FStrm.Write( nSize, SizeOf( nSize ) );
          nSize := nSize * 2;
        End;
      end;
      FStrm.Write( p^, nSize );
    End;
end;

procedure TMStreamSerializer.ReadObject(aObj: TObject);
Var
    pList : TMPropList;
    pInfo : PPropInfo;
    i : Integer;
    tmpobj : TObject;
begin
    pList := TMPropList.Create( aObj );
    Try
        For i := 0 To pList.PropCount - 1 Do
        Begin
            pInfo := pList.Props[i];
            If ( pInfo^.PropType^.Kind = tkClass ) Then
            Begin
                tmpobj := TObject( Integer( GetPropValue( aObj, pInfo^.Name ) ) );
                ReadValue( pInfo^.PropType^, tmpobj );
            End
            Else If ( pInfo^.PropType^.Kind In csTypeKindFilter ) Then
                SetPropValue( aObj, pInfo^.Name, ReadValue( pInfo^.PropType^ ) );
        End;
    Finally
        pList.Free;
    End;
end;

procedure TMStreamSerializer.WriteObject(const aObj: TObject);
Var
    pList : TMPropList;
    pInfo : PPropInfo;
    i : Integer;
begin
    pList := TMPropList.Create( aObj );
    Try
        For i := 0 To pList.PropCount - 1 Do
        Begin
            pInfo := pList.Props[i];
            If ( pInfo^.PropType^.Kind In csTypeKindFilter ) Then
                WriteValue( pInfo^.PropType^, GetPropValue( aObj, pInfo^.Name ) );
        End;
    Finally
        pList.Free;
    End;
end;

procedure TMStreamSerializer.Free;
begin
    _Release( );
end;

{ TMXMLSerializer }

constructor TMXMLSerializer.Create(aNode: IXMLNode; aName : String);
begin
    Inherited Create;
    FNode := aNode;
    FCurNode := aNode;
    FCurName := aName;
    _AddRef( );
end;

function TMXMLSerializer.NeedCount: Boolean;
begin
    Result := false;
end;

function TMXMLSerializer.ReadValueCount: Integer;
begin
    FCurName := csSequence;
    Result := FCurNode.ChildNodes.Count;
    FCurNode := FCurNode.ChildNodes.First;
end;

procedure TMXMLSerializer.WriteValueCount(aCount: Integer);
begin
    //FCurNode.Attributes[csSequence] := csTrue;
end;

function TMXMLSerializer.ReadValue(aTypeInfo: PTypeInfo; aObj : TObject): Variant;
Var
    intf     : IMSerializable;
    sOldName : String;
    pNode    : IXMLNode;
    bSeq     : Boolean;
begin
    Result   := 0;
    bSeq     := ( FCurName = csSequence );
    sOldName := FCurName;
    pNode    := FCurNode;
    If ( aTypeInfo^.Kind = tkClass )
        AND ( Not Supports( aObj, IMStatefulSerializable, intf ) )
        AND ( Not Supports( aObj, IMSerializable, intf ) ) Then
        ReadObject( aObj )
    Else
    Begin
        If Not bSeq Then
            FCurNode := FCurNode.ChildNodes.Nodes[FCurName];
        If ( aTypeInfo^.Kind = tkClass ) Then
        Begin
            intf.SerializeRead( Self );
            intf := Nil;
        End
        Else
            Result := FCurNode.Text;
    End;
    FCurNode := pNode;
    FCurName := sOldName;

    pNode := FCurNode.ParentNode;
    If Assigned( pNode ) AND bSeq Then
    Begin
        FCurNode := FCurNode.NextSibling;
        If Not Assigned( FCurNode ) Then
            FCurNode := pNode.ParentNode;
    End;
end;

procedure TMXMLSerializer.WriteValue(aTypeInfo: PTypeInfo;
  const Value: Variant);
Var
    obj  : TObject;
    intf : IMSerializable;
    pNode : IXMLNode;
begin
    pNode := FCurNode;
    If aTypeInfo^.Kind = tkClass Then
    Begin
        obj := TObject( Integer( Value ) );
        If Supports( obj, IMStatefulSerializable, intf )
          OR Supports( obj, IMSerializable, intf ) Then
        Begin
            FCurNode := FCurNode.AddChild( FCurName );
            FCurName := csSequence;
            intf.SerializeWrite( Self );
            intf := Nil;
        End
        Else
            WriteObject( obj );
    End
    Else
    Begin
        FCurNode := FCurNode.AddChild( FCurName );
        If ( aTypeInfo^.Name = csTGUID ) Then
            FCurNode.Text := GUIDToString( TGUID( Value ) )
        Else
            FCurNode.Text := String( Value );
    End;
    FCurNode := pNode;
end;

procedure TMXMLSerializer.ReadObject(aObj: TObject);
Var
    pList : TMPropList;
    pInfo : PPropInfo;
    i : Integer;
    tmpobj : TObject;
    sOldName:String;
    pNode  : IXMLNode;
    bSeq   : Boolean;
begin
    pList := TMPropList.Create( aObj );
    Try
        bSeq := ( FCurName = csSequence );
        sOldName := FCurName;
        pNode    := FCurNode;
        If Not bSeq Then
            FCurNode := FCurNode.ChildNodes.Nodes[FCurName];
        For i := 0 To pList.PropCount - 1 Do
        Begin
            pInfo := pList.Props[i];
            FCurName := pInfo^.Name;
            If ( pInfo^.PropType^.Kind = tkClass ) Then
            Begin
                tmpobj := TObject( Integer( GetPropValue( aObj, pInfo^.Name ) ) );
                ReadValue( pInfo^.PropType^, tmpobj );
            End
            Else If ( pInfo^.PropType^.Kind In csTypeKindFilter ) Then
                SetPropValue( aObj, pInfo^.Name, ReadValue( pInfo^.PropType^ ) );
        End;
        FCurNode := pNode;
        FCurName := sOldName;
        If bSeq Then
        Begin
            pNode := FCurNode.ParentNode;
            If Assigned( pNode ) Then
            Begin
                FCurNode := FCurNode.NextSibling;
                If Not Assigned( FCurNode ) Then
                    FCurNode := pNode.ParentNode;
            End
        End;
    Finally
        pList.Free;
    End;
end;

procedure TMXMLSerializer.WriteObject(const aObj: TObject);
Var
    pList : TMPropList;
    pInfo : PPropInfo;
    i : Integer;
    sOldName : String;
    pNode    : IXMLNode;
begin
    sOldName := FCurName;
    pNode    := FCurNode;
    FCurNode := FCurNode.AddChild( FCurName );
    pList := TMPropList.Create( aObj );
    Try
        For i := 0 To pList.PropCount - 1 Do
        Begin
            pInfo := pList.Props[i];
            If ( pInfo^.PropType^.Kind In csTypeKindFilter ) Then
            Begin
                FCurName := pInfo^.Name;
                WriteValue( pInfo^.PropType^, GetPropValue( aObj, pInfo^.Name ) );
            End;
        End;
    Finally
        pList.Free;
    End;
    FCurNode := pNode;
    FCurName := sOldName;
end;

procedure TMXMLSerializer.Free;
begin
    _Release( );
end;

end.
